%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


% code for table 1, recursive H+N
close all; clear all;

%%%%%%%%%%%%%%%%%%%%
% signal synthesis %
%%%%%%%%%%%%%%%%%%%%
Fe = 8000 ; 
N = 4000;
nu = [400 440 2000];
n = 200; % longueur d'analyse


sig = .1; % ?cart type du bruit

t = (0:N-1)/Fe;

a = zeros(length(nu),N);
a(1,:) = exp(-t/.2);
a(2,:) = hanning(N)';
deb=500;
a(3,:) = [zeros(1,deb),1+.2*cos(2*pi*5*t(deb+1:end-deb)),zeros(1,deb)];
dect = 500;

vara = sig^2*3/pi^2/((nu(2)-nu(1))/Fe)^2/n^3;
dnu = (nu(2)-nu(1))/Fe;dR = n^2-sin(pi*n*dnu)^2/sin(pi*dnu)^2;varavraie = sig^2*n/dR;
vara3 = sig^2/n;
sqrt(vara)
sqrt(varavraie)

s = zeros(1,N);
for k=1:length(nu)
   s = s + exp( j*2*pi*nu(k)*t+2*j*pi*rand).*a(k,:);
end

b = sig/sqrt(2)*(randn(1,N)+j*randn(1,N));
rsb = 10*log10(var(s)/var(b))
s = s(:)+b(:);

z = exp(j*2*pi*nu(:)/Fe);

[amp,xc,er] = fastls(s,z,n);

%%%%%%%%%%%%%%%%%%
% affichage      %
%%%%%%%%%%%%%%%%%%
figure; 
for k=1:length(nu); 
   plot(t+(n-1)/2/Fe,abs(amp(k,:)),'color',[1 1 1]*.7);hold on;
end

for k=1:length(nu); 
   plot(t,a(k,:),'k');%hold on;
end
axis([0 0.5 -.1 1.4])
xlabel('time (s)','fontsize',14);
ylabel('amplitudes','fontsize',14);
set(gca,'fontsize',14);