% We make root-music adaptative by iterating a Newton-type algorithm
% with a subspace tracker: FAPI
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


% construction du signal
close all; clear all;
s = wavread('../../../audio/notepiano');s =decimate(s,2);Fe = 22050;
s = s(.94*Fe:1.3*Fe);
N = length(s);
s = preprocess(s,Fe,12);
s = hilbert(s);
s = s/max(abs(s));

% initialisation
% calcul de la base signal
P = 121;% Rss : PxP 
Ns = 10;% taille de l'espace signal
dyn = 300; % dynamique de l'affichage

beta = 0.99;
muL = 0.99;
muV = 0.5;

disp('hrhatrack');
[freqs,amps]=hrhatrack(s,Ns,P,beta,muL,muV);

disp('Affichage')
ret = P;
ampsc = amps(:,ret+1:end);
ampsc = db(ampsc./max(ampsc(:)));ampsc(ampsc < -dyn)=-dyn;
close all

df = 0.002; % epaisseur de la ligne fr?quentielle

for k=1:Ns
   
surf( ones(2,1)*(0:length(freqs(1,:))-ret-1)/Fe,[freqs(k,ret+1:end);freqs(k,ret+1:end)+df]*Fe,...
    ones(2,1)*ampsc(k,:));hold on
end
view([0 90])
shading interp
cm = colormap;
set(gca,'color',cm(1,:))


grid
xlabel('time t (s)');
ylabel('frequency (Hz)');
caxis([-110 -10])
axis([0 0.2 0 10000])