% Version of FAPI + adaptation of the poles by means of a gradient descent algorithm
% line crossing test
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

% construction du signal
close all; clear all;

N = 2000;  % nb de points
Nb = 100; % nombre de points de zeros avant les sinus.
Fe = 1;
t = 0:N-Nb-1;
nu = 0.1*(1+0.2*sin(2*pi*0.001*t)); % modulation de freq
%nu = .1+.1*t/t(end);    
nu2 = nu+0.02;%.12+.07*t/t(end); % modulation de freq

%nu2 = nu2(end:-1:1);
phi = 0; a1 = 1;a2 =0.2; 
phiinst = phi + cumsum(2*pi*nu);
phiinst2 = phi + cumsum(2*pi*nu2);

s = a1*exp(j*phiinst)+a2*exp(j*phiinst2);




sg = 0.1; % bruit;
b= sg/sqrt(2)*(randn(1,N)+j*randn(1,N));
s = [zeros(1,Nb) s];
rsb = 10*log10(var(s)/var(b))
s = s + b;
s = s(:);

Ns = 2;P=61;
beta = 0.9;
muL = 0.9;
muV = 0.9;
[freqs,amps]=hrhatrack(s,Ns,P,beta,muL,muV);


ret = 0;% -round(3/log(muL)); % delay
close all

Fe = 1;
hgt = plot(t+Nb,nu,'b');
axis([t(1) t(end) min([nu,nu2])*0 max([nu,nu2])*1.5]);
hold on;
plot(t+Nb,nu2,'b');
for k=1:Ns
hhra=plot( 0:(N-P-ret-1),freqs(k,ret+1:end),'r');hold on
end
grid
xlabel('time t (samples)');
ylabel('frequency');
hl=legend([hgt hhra],'ground truth','HRHATRAC estimates');

