function V = vdm(z,N);

% function V = vdm(z,N);
% Vandermonde matrix 
% from the poles z for an order N
% V =   | 1    1    ..    1    |
%       | z0   z1   ..    zk   |
%       |  ...                 |
%       | z0^(N-1) z1^(N-1) ..    zk^(N-1) |
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

z = z(:).';n=(0:N-1)';
V = exp( n*log(z) );