%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

[d,r] = wavread('clar.wav');
S = specgram(d,256);  % SP Toolbox routine (or use ifgram.m below)

[F, A, Ph] = spectrogram2peaks(S, r, 20);
tt = (1:size(F, 2))*128/r;  % default specgram step is NFFT/2 i.e. 128

[P,Zi,Zf,Za,trC,ffx,ffy,fax,fay,tag]=peaks2partialsHF(A,F);
E=NaN * ones(tag,size(F,2));

for c=1:size(P,2)
   for l=1:size(P,1)
       if((F(l,c)~=0)&&(P(l,c)~=0))
            E(P(l,c),c)=F(l,c);
       end
   end
end


figure('Name','HF','NumberTitle','off')
clf
specgram(d,256,r)
colormap(1-gray)
hold on
for l=1:size(E,1)
    L=E(l,:);
    if(mod(l,7)==0)
        plot(tt,L','r');
    else if (mod(l,7)==1)
            plot(tt,L','g');
        else if (mod(l,7)==2)
            plot(tt,L','b');
            else if (mod(l,7)==3)
                plot(tt,L','c');
                else if (mod(l,7)==4)
                    plot(tt,L','m');
                    else if (mod(l,7)==5)
                        plot(tt,L','y');
                        else if (mod(l,7)==6)
                                plot(tt,L','w');
                            end
                        end
                    end
                end
            end
        end
    end
end
