function [ P,Zi,Zf,Za,trameCouranteZ,Ffx,Ffy,Fax,Fay,tag] = peaks2partialsHF( A, F, T, deltaF, dureeActif, Zi, Zf, Za, Ffx,Ffy,Fax,Fay, trameCouranteZ, tag )
% A : amplitudes of the peaks
% F : frequencies of the peaks (in Hz)%T : ]0; 1] permits to more or less penalize the use of interpoled peaks
%Zf : matrice de sauvegarde des frquences des partiels
%Za : matrice de sauvegarde des amplitudes des partiels
%Zi : 1re colonne: numero du partiel
%     2me colonne: compteur de dure d'activation 
%     3me colonne: nombre de donnes anciennement sauvegardes disponibles
%     4me colonne: premire valeur frquentielle.
%     5me colonne: premire valeur de l'amplitude.
%Ffx Ffy matrice de sauvegarde filtres frequence
%Fax Fay matrice de sauvegarde filtres amplitude
%Chaque ligne de Zf, ,Za, Zi, Ffx,Ffy, Fax,Fay  correspond  un mme partiel
%trameCouranteZ correspond  la trame courante dans les 7 matrices de sauvegardes Zf, ,Za, Zi, Ffx,Ffy, Fax,Fay
%dureeActif correspond au nombre de trame pendant lequel un partiel qui ne
%trouve pas de pic valable,reste actif.
%dureeActif doit tre infrieur  size(Zf,2)-1; 
%%tag : numero du dernier partiel
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.


if nargin<2, [A,F]=tone2peaks();end
if nargin<3, T=0.6;end
if nargin<4, deltaF=40;end
if nargin<5,dureeActif=7;end
if nargin<14, Zi=zeros(10,5);Zf=zeros(10, 20);Za=zeros(10, 20);Ffx=zeros(10, 20); Ffy=zeros(10, 20);Fax=zeros(10, 20); Fay=zeros(10, 20);trameCouranteZ=1;tag=1;end

nbTrames= size(F, 2);
nbPeaks= size(F, 1);
n=size(Zf,2);
nf=4;   % nombres de trames futures considrs pour la prdiction
%coeff pour IRR
c=[0.7358,1.0762,0.5540,0.2346];
d=[0.06,-0.2274,0.335,-0.2274,0.06];

P=zeros(nbPeaks,nbTrames);  %matrice des indices des partiels


for t=1:nbTrames  %Parcours des trames de F
    tabPeaks=ones(1,nbPeaks);%tab pour connaitre les peaks non utiliss
    
    for l=1:size(Zf,1) 
        if(Zi(l,1)~=0)
            
            if(Zi(l,3)<4)%si le nombre de donnes est inf  4 alors methode de MAQ
                est_x=Zf(l,mod(trameCouranteZ-2,n)+1);
                %recherche du peak le plus proche de la valeur antrieure
                indPeak=0;
                deltaF2=deltaF;
                for p=1:nbPeaks
                    if(tabPeaks(p)==1 && abs(F(p,t)-est_x)<deltaF2 )
                        indPeak=p;
                        deltaF2=abs(F(p,t)-est_x);
                    end
                end
                if(indPeak~=0)
                    tabPeaks(indPeak)=0;
                    Zi(l,2)=dureeActif;
                    Zf(l,trameCouranteZ)=F(indPeak,t);
                    Za(l,trameCouranteZ)=A(indPeak,t);
                    P(indPeak,t)=Zi(l,1);
                    
                else
                    Zi(l,2)=Zi(l,2)-1; 
                    if (Zi(l,2)==0)
                        Zi(l,1)=0; 
                        continue;
                    end
                    Zf(l,trameCouranteZ)=Zf(l,mod(trameCouranteZ-2,n)+1);
                    Za(l,trameCouranteZ)=Za(l,mod(trameCouranteZ-2,n)+1);
                end
                % mise  jour de la mmoire des filtres
                     %freq
                    Ffx(l,trameCouranteZ)=Zf(l,trameCouranteZ)-Zi(l,4);
                     %ampl
                    Fax(l,trameCouranteZ)=Za(l,trameCouranteZ)-Zi(l,5);
                    
            else
            
                % Calculs des prdictions
                
                X=zeros(2,Zi(l,3)+ nf); %matrice des dernires et futures valeurs du partiel; 1re ligne:freq ; 2me ligne:amplitudes 
                for p=1:size(X,2)-nf %reconstitution des dernires donnes du partiel 
                    X(1,p)=Zf(l,mod(trameCouranteZ-2-Zi(l,3)+p,n)+1);
                    X(2,p)=Za(l,mod(trameCouranteZ-2-Zi(l,3)+p,n)+1);            
                    if(p==1) %on vrifie que les valeurs ne soit pas les mmes car calcul de la prdiction ne marche pas 
                        verifId=X(1,1);
                    end
                    if(verifId~=X(1,p))
                        verifId=-1;
                    end
                end
    
        
                for p=1:nf%calculs des nf prdictions
                    x=X(:,p:size(X,2)-nf+ p-1);%matrice des valeurs ncessaire pour le calcul en cours
                    if(verifId==-1)
                            estF_x=0;
                            estA_x=0;
                            aF=arburg(x(1,:),floor((size(x,2)-1)/2)); %calculs des coeff
                            aA=arburg(x(2,:),floor((size(x,2)-1)/2));
                            for g=2:size(aF,2)
                                estF_x=estF_x - aF(g)*x(1,size(x,2)+1-g);%calculs des prdiction
                                estA_x=estA_x - aA(g)*x(1,size(x,2)+1-g);
                            end
                    else
                            estF_x=x(1,1);
                            estA_x=x(2,1);
  
                    end
                    X(1,size(X,2)-nf+ p)=estF_x;
                    X(2,size(X,2)-nf+ p)=estA_x;
                end
          
            
            
            % Slections des 2 pics les plus proches parmis tous ceux disponibles pour les nf trames
          
                indPeaks=zeros(2,nf);%matrice des indices des pics slectionns pour les 4 trames suivantes; colonne:trame; ligne1:pic le plus proche de la prdiction; ligne2:2me pic le plus proche de la prdiction
                for g=1:nf
                    deltaF2 = deltaF;
                    for p=1:nbPeaks
                        if(t<=nbTrames-3)
                            if(tabPeaks(p)==1 && abs(F(p,t+g-1)-X(1,Zi(l,3)+g))<deltaF2)
                                indPeaks(2,g)=p;
                                deltaF2=abs(F(p,t+g-1)-X(1,Zi(l,3)+g));
                                if(indPeaks(1,g)==0)
                                   indPeaks(2,g)=p; 
                                else
                                    if(abs(F(p,t+g-1)-X(1,Zi(l,3)+g))<abs(F(indPeaks(1,g),t+g-1)-X(1,Zi(l,3)+g)) )
                                        indPeaks(2,g)=indPeaks(1,g);
                                        indPeaks(1,g)=p;
                                        deltaF2=abs(F(indPeaks(2,g),t+g-1)-X(1,Zi(l,3)+g));
                                    end
                                end
                            end
                        end
                    end
                end
       
            % choix de la trajectoire (cette partie ne permet pas un nf gnrique, nf=4 forcment)
                %calcul du cout pour chaque trajectoire possible
                Nt=0; %nombre de pic calculs dans la trajectoire
                coutMin=0;
                indMin=0;
                trajFA=zeros(2,nf+4);
                trajFA(1,1:4)=X(1,Zi(l,3)-3:Zi(l,3)); %1re ligne frquence des pics du partiel choisi 
                trajFA(2,1:4)=X(2,Zi(l,3)-3:Zi(l,3)); %2me ligne amplitude des pics du partiel choisi
                
                Fftemp=zeros(2,nf+4);
                for b=1:4 %reconstitution des dernires donnes des filtres freq du partiel 
                    Fftemp(1,b)=Ffx(l,mod(trameCouranteZ-2-4+b,n)+1);
                    Fftemp(2,b)=Ffy(l,mod(trameCouranteZ-2-4+b,n)+1); 
                end
                
                 Fatemp=zeros(2,nf+4);
                for b=1:4 %reconstitution des dernires donnes du filtres ampl du partiel 
                    Fatemp(1,b)=Fax(l,mod(trameCouranteZ-2-4+b,n)+1);
                    Fatemp(2,b)=Fay(l,mod(trameCouranteZ-2-4+b,n)+1); 
                end
                
                for p1=1:3   %pn=1 correspond  la valeur du pic le plus proche ;pn=2 : valeur du 2me pic le plus proche ;pn=3 valeur prdite
    
                    if (p1==3)
                        trajFA(1,5)=X(1,Zi(l,3)+1);
                        trajFA(2,5)=X(2,Zi(l,3)+1);
                        indChoisi=0;
                        Nt=Nt+1;

                    else
                        if(indPeaks(p1,1)==0) %pas de valeur;
                            continue %on passe  la prochaine trajectoire
                        end
                        trajFA(1,5)=F(indPeaks(p1,1)); 
                        trajFA(2,5)=A(indPeaks(p1,1));
                        indChoisi=indPeaks(p1,1);
                    end
                    for p2=1:3
                        if (p2==3)
                        trajFA(1,6)=X(1,Zi(l,3)+2);
                        trajFA(2,6)=X(2,Zi(l,3)+2);
                        Nt=Nt+1;
                        else
                            if(indPeaks(p2,2)==0)
                                continue
                            end
                            trajFA(1,6)=F(indPeaks(p2,2)); 
                            trajFA(2,6)=A(indPeaks(p2,2));
                        end
                        for p3=1:3
                            if (p3==3)
                                trajFA(1,7)=X(1,Zi(l,3)+3);
                                trajFA(2,7)=X(2,Zi(l,3)+3);
                                Nt=Nt+1;
                            else
                                if(indPeaks(p3,3)==0)
                                    continue
                                end
                                trajFA(1,7)=F(indPeaks(p3,3)); 
                                trajFA(2,7)=A(indPeaks(p3,3));
                            end
                            for p4=1:3
                                if (p4==3)
                                    trajFA(1,8)=X(1,Zi(l,3)+4);
                                    trajFA(2,8)=X(2,Zi(l,3)+4);
                                    Nt=Nt+1;
                                else
                                    if(indPeaks(p4,4)==0)
                                        continue
                                    end
                                    trajFA(1,8)=F(indPeaks(p4,4)); 
                                    trajFA(2,8)=A(indPeaks(p4,4));
                                end
                                % Estimation du contenu haute frquence
                                %pour les freq
                                for p=5:8
                                    Fftemp(1,p)=trajFA(1,p)-Zi(l,4);
                                    Fftemp(2,p)=sum(d.*Fftemp(1,p:-1:p-4))-sum(c.*Fftemp(2,p-1:-1:p-4));
                                end
                                %pour les ampl
                                for p=5:8
                                    Fatemp(1,p)=trajFA(2,p)-Zi(l,5);
                                    Fatemp(2,p)=sum(d.*Fatemp(1,p:-1:p-4))-sum(c.*Fatemp(2,p-1:-1:p-4));
                                end
                                % calcul du cout
                                
                                cout=((1/T)^Nt)*sum(Fatemp(2,5:8).*Fatemp(2,5:8))*sum(Fftemp(2,5:8).*Fftemp(2,5:8));
                               
                                if(coutMin==0||cout<coutMin)
                                    coutMin=cout;
                                    indMin=indChoisi;
                                end
                            end
                        end
                    end
                end
             
                 %mise a jour des Z
                if(indMin~=0)
                     tabPeaks(indMin)=0;
                     Zi(l,2)=dureeActif;
                     Zf(l,trameCouranteZ)=F(indMin,t);
                     Za(l,trameCouranteZ)=A(indMin,t);
                     P(indMin,t)=Zi(l,1);
                     
                     % mise  jour de la mmoire des filtres
                     %freq
                    Ffx(l,trameCouranteZ)=F(indMin,t)-Zi(l,4);
                    Fftemp(1,5)=F(indMin,t)-Zi(l,4);
                    Ffy(l,trameCouranteZ)=sum(d.*Fftemp(1,5:-1:1))-sum(c.*Fftemp(2,4:-1:1));
                    
                    %ampl
                    Fax(l,trameCouranteZ)=A(indMin,t)-Zi(l,5);
                    Fatemp(1,5)=A(indMin,t)-Zi(l,5);
                    Fay(l,trameCouranteZ)=sum(d.*Fatemp(1,5:-1:1))-sum(c.*Fatemp(2,4:-1:1));
                     
                else
                    Zi(l,2)=Zi(l,2)-1; 
                    if (Zi(l,2)==0)
                        Zi(l,1)=0;
                        continue
                    end
                    Zf(l,trameCouranteZ)=X(1,Zi(l,3)+1);                
                    Za (l,trameCouranteZ)=X(2,Zi(l,3)+1);
                    
                    % mise  jour de la mmoire des filtres
                    Ffx(l,trameCouranteZ)=X(1,Zi(l,3)+1)-Zi(l,4);
                    Fftemp(1,5)=X(1,Zi(l,3)+1)-Zi(l,4);
                    Ffy(l,trameCouranteZ)=sum(d.*Fftemp(1,5:-1:1))-sum(c.*Fftemp(2,4:-1:1));
                    
                    Fax(l,trameCouranteZ)=X(2,Zi(l,3)+1)-Zi(l,5);
                    Fatemp(1,5)=X(2,Zi(l,3)+1)-Zi(l,5);
                    Fay(l,trameCouranteZ)=sum(d.*Fatemp(1,5:-1:1))-sum(c.*Fatemp(2,4:-1:1));
         
                end
            end
            if(Zi(l,3)<n-1)
                Zi(l,3)=Zi(l,3)+1;
            end
        end
    end
    
  
     %cration des nouveaux partiels
    for p=1:nbPeaks
        if(tabPeaks(p)==1 && F(p,t)~=0)
            indLibre=0;
            for h=1:size(Zi,1)
                if (Zi(h,1)==0)
                   indLibre=h; 
                   break;
                end
            end
            if(indLibre==0)
               Zf=[Zf;zeros(1,n)];
               Za=[Za;zeros(1,n)];
               Zf(size(Zf,1),trameCouranteZ)=F(p,t);
               Za(size(Za,1),trameCouranteZ)=A(p,t);
               Zi=[Zi;zeros(1,5)];
               Zi(size(Zi,1),1)= tag;
               Zi(size(Zi,1),2)= dureeActif;
               Zi(size(Zi,1),3)=1;
               Zi(size(Zi,1),4)=F(p,t);
               Zi(size(Zi,1),5)=A(p,t);
               Ffx=[Ffx;zeros(1,n)];
               Ffy=[Ffy;zeros(1,n)];
               Fax=[Fax;zeros(1,n)];
               Fay=[Fay;zeros(1,n)];
            else
               Zf(indLibre,trameCouranteZ)=F(p,t);
               Za(indLibre,trameCouranteZ)=A(p,t);
               Zi(indLibre,1)= tag;
               Zi(indLibre,2)= dureeActif;
               Zi(indLibre,3)=1;
               Zi(indLibre,4)=F(p,t);
               Zi(indLibre,5)=A(p,t);
               
               Ffx(indLibre,:)=zeros(1,n);
               Ffy(indLibre,:)=zeros(1,n);
               Fax(indLibre,:)=zeros(1,n);
               Fay(indLibre,:)=zeros(1,n);
            end
            P(p,t)=tag;  
            tag=tag+1; 
        end
    end
    
    % ordonnancement
    
    for p=1:size(Zf,1)
        indMatureAmplitudeMax=p;
        for m=p:size(Zf,1)
           if(Zi(m,3)>3 && Za(m,trameCouranteZ)> Za(indMatureAmplitudeMax,trameCouranteZ)) 
              indMatureAmplitudeMax=m;
           end
        end
        if(indMatureAmplitudeMax~=p)
            temp=zeros(1,size(Zf,2));
            temp(1,:)=Zf(p,:);
            Zf(p,:)=Zf(indMatureAmplitudeMax,:);
            Zf(indMatureAmplitudeMax,:)=temp(1,:);
    
            temp=zeros(1,size(Zi,2));
            temp(1,:)=Zi(p,:);
            Zi(p,:)=Zi(indMatureAmplitudeMax,:);
            Zi(indMatureAmplitudeMax,:)=temp(1,:);
    
            temp=zeros(1,size(Za,2));
            temp(1,:)=Za(p,:);
            Za(p,:)=Za(indMatureAmplitudeMax,:);
            Za(indMatureAmplitudeMax,:)=temp(1,:);
            
            temp=zeros(1,size(Ffx,2));
            temp(1,:)=Ffx(p,:);
            Ffx(p,:)=Ffx(indMatureAmplitudeMax,:);
            Ffx(indMatureAmplitudeMax,:)=temp(1,:);
            
            temp=zeros(1,size(Ffy,2));
            temp(1,:)=Ffy(p,:);
            Ffy(p,:)=Ffy(indMatureAmplitudeMax,:);
            Ffy(indMatureAmplitudeMax,:)=temp(1,:);
            
            temp=zeros(1,size(Fax,2));
            temp(1,:)=Fax(p,:);
            Fax(p,:)=Fax(indMatureAmplitudeMax,:);
            Fax(indMatureAmplitudeMax,:)=temp(1,:);
            
            temp=zeros(1,size(Fay,2));
            temp(1,:)=Fay(p,:);
            Fay(p,:)=Fay(indMatureAmplitudeMax,:);
            Fay(indMatureAmplitudeMax,:)=temp(1,:);
        end
    end
    
    trameCouranteZ=mod(trameCouranteZ,size(Zf,2))+1;
end


