function S = tones2spectrogram(A, F, sr, numberOfBins)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

if nargin<3
    sr = 44100;
end
if nargin<4
    numberOfBins = 1024;
end

S = zeros(numberOfBins, size(A, 2));
for k=1:size(A, 1)
    for l=1:size(A, 2)
        bin = ceil(F(k, l)/sr*numberOfBins);
        if bin
            S(bin, l) =  S(bin, l)+A(k, l);
        end
    end
end