function [a_var, mu_var, phi_var, omega_var, psi_var] = error_variance (Fs, a_err, mu_err, phi_err, omega_err, psi_err)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

  % amplitude
  a_var = var (a_err.');

  % amplitude modulation
  mu_var = var (mu_err.' / Fs);

  % phase
  ind = find (phi_err >= pi);
  phi_err(ind) = phi_err(ind) - 2*pi;
  ind = find (phi_err <= -pi);
  phi_err(ind) = phi_err(ind) + 2*pi;
  phi_var = var (phi_err.');

  % frequency
  omega_var = var (omega_err.' / Fs);

  % frequency modulation
  psi_var = var (psi_err.' / (Fs^2));

end
