function [X, X1, X2] = compute_spectra (N, Fs, x, d1, d2, omega)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

  L = size (omega, 2);
  Mx = repmat (x, L, 1);
  Md1 = repmat (d1, L, 1);
  Md2 = repmat (d2, L, 1);
  t = time_axis (N, Fs);
  X = transpose (sum (Mx .* exp (-i*omega.'*t), 2));
  X1 = transpose (sum (Md1 .* exp (-i*omega.'*t), 2));
  X2 = transpose (sum (Md2 .* exp (-i*omega.'*t),2));

end
