function [Y,S,Sp1] = estimation(a,b,P,Q,pitch);
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

a0 = a; b0 = b;

[s,Fs] = wavread('an_ein_on'); s = decimate(s,2); Fs = Fs / 2; s=s(6000+1:6000+round(60e-3*Fs)); s = s - mean(s);
P2 = round(Fs / pitch);
x = [ones(1,pitch)*sqrt(P2);zeros(P2-1,pitch)]; x = x(:);
x = filter(b,a,x(:));
x = x(201:200+length(s));
x = x - mean(x);

N = 1024;
S = fft(x.*hanning(length(x)),N);
S = abs(S).^2 / length(x);
Sp1 = [];
if Q >= 2,
    % Mthode de Durbin;
    gamma = conv(x,x(end:-1:1));
    zero = (length(gamma)+1)/2;
    R = toeplitz(gamma(zero+Q:zero+Q+P-1),gamma(zero+Q:-1:zero+Q-P+1));
    r = gamma(zero+Q+1:zero+Q+P);
    a1 = [1;- pinv(R)*r];
    % Mthode n 1
    s2 = filter(a1,1,x);
    s2 = s2(length(a1):end);
    gamma = conv(s2,s2(end:-1:1));
    gamma = gamma((length(gamma)+1)/2:end);
    psi = levinson(gamma,100);
    psi = psi(2:end);
    Psi = toeplitz([1,psi,zeros(1,Q-2)],eye(1,Q));
    b1 = [1;-pinv(Psi)*[psi(1:end-1).'; zeros(Q,1)]];
    s2 = filter(a1,b1,x);
    sigma1 = norm(s2(120:end))^2/length(s2(120:end));
    Sp1 = freqz(sqrt(sigma1)*b1,a1,N/2);
    Sp1 = 20*log10(abs(Sp1));
end;

% Estimation MA
n = 0:N-1;
gamma = zeros(N,1);
k = 1;
index = [];
top = round(N*pitch/Fs);
while k <= N/2-(top+2),
    [bidon,I] = max(S(k+top-2:k+top+2));    
    k = k + top-3 + I;
    index = [index,k];
end;
for k=2:length(index)-1,
    if S(index(k)) < 0.1 * (S(index(k-1)) + S(index(k+1))),
        index(k) = round((index(k-1)+index(k+1))/2);
    end;
end;
gamma(index) = 1;
gamma(N+2-index(2:end)) = 1;
gamma = gamma / sum(gamma);
Y0 = S;

% Estimation perso
a = eye(P+1,1);
b = eye(Q+1,1);
sigma = 1;
n = 0:N-1;
L = [];
for repete = 1:100,
    old_a = zeros(size(a));
    old_b = zeros(size(b));
    Ya = abs(a'*exp(-2*pi*i*(0:P)'*n/N)).^2; Ya = Ya';
    Yb = abs(b'*exp(-2*pi*i*(0:Q)'*n/N)).^2; Yb = Yb';
    count = 0;
    while (max(abs(a-old_a))> 1e-4) & (count < 10),
        old_a = a;
        Ya = abs(a'*exp(-2*pi*i*(0:P)'*n/N)).^2; Ya = Ya';
        r1 = real(ifft(gamma.*Y0./Yb));
        R1 = toeplitz(r1(1:P+1));
        r2 = real(ifft(gamma./Ya));
        R2 = toeplitz(r2(1:P+1));
        a = pinv(R1) * R2 * a;
        racines = roots(a);
        I = find(abs(racines)>1);
        racines(I) = conj(1./racines(I));
        a = poly(racines)';
        count = count + 1;
    end;
    count = 0;
    while (max(abs(b-old_b))> 1e-3) & (count < 10),
        old_b = b;
        Yb = abs(b'*exp(-2*pi*i*(0:Q)'*n/N)).^2; Yb = Yb';
        r1 = real(ifft(gamma.*Y0.*Ya./Yb.^2));
        R1 = toeplitz(r1(1:Q+1));
        r2 = real(ifft(gamma./Yb));
        R2 = toeplitz(r2(1:Q+1));
        b = pinv(R2) * R1 * b;
        b = b / b(1);
        racines = roots(b);
        I = find(abs(racines)>1);
        racines(I) = conj(1./racines(I));
        b = poly(racines)';
        count = count + 1;
    end;
    sigma = sqrt(sum(gamma.*Y0.*Ya./Yb));
    Y = sigma^2 * Yb ./ Ya;
    L = [L,sum(log(Y0./Y)-Y0./Y)];L(end);
end;