function E = arspecCompute(S, ap)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

E = zeros(ap.te.envelopeLength, size(S, 2));
for k=1:size(S, 2)
    s=S(:, k);
    cs = [s(1:end-1); flipud(s(1:end-1))];
    va = real(ifft(cs));
    [vaAr nm] = aryule(va, ap.ar.order);
    vaAR = freqz(1, vaAr, length(s));
    e = abs(vaAR)*sqrt(sqrt(nm));
    E(:, k) = e(1:ap.te.envelopeLength);

%          clf
%          hold on
%          plot(lin2db(s))
%          plot(lin2db(e), 'r');
end