function [ft, metaFeaturesId longtermFeaturesId, lateIntegrationId] = getFeatureType(id)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

metaFeatures={'mfccdelta', 'mfarspec', 'mftespec', ...
%     'ltfspecsel', ...
%     'ltaspecsel', 'ltapspecsel', 'ltamspecsel', ...
%     'ltmspecsel', 'ltmpspecsel', 'ltmmspecsel' ...
    };

lateIntegrationFeatures = {'mfcc', 'mfccdelta'};

longtermFeatures={...
    'ltf', 'ltfspec', 'ltfspecsel', 'ltfar', 'ltfarspec', 'ltfarspecsel', ...
    'lta', 'ltaspec', 'ltaspecsel', 'ltaar', 'ltaarspec', 'ltaarspecsel', ...
    'ltap', 'ltapspec', 'ltapspecsel', 'ltapar', 'ltaparspec', 'ltaparspecsel', ...
    'ltm', 'ltmspec', 'ltmspecsel', 'ltmar', 'ltmarspec', 'ltmarspecsel', ...
    'ltmp', 'ltmpspec', 'ltmpspecsel', 'ltmpar', 'ltmparspec', 'ltmparspecsel', ...
    'ltmspecm', 'ltmspecselm', 'ltmarspecm', 'ltmarspecselm', ...
    'ltaspecm', 'ltaspecselm', 'ltaarspecm', 'ltaarspecselm', ...
    };

ft = {'peaks', ...
    'mfccearly', 'mfcc', 'mfccdelta', ...
    'arspec', 'mfarspec', 'tespec', 'mftespec', ...
    };
ft(length(ft)+1:length(ft)+length(longtermFeatures)) = longtermFeatures;

if nargin==1 && sum(id)>0
    tft=cell(1, length(id));
    for k=1:length(id)
        tft(k) = ft(id(k));
    end
    ft = tft;
end

metaFeaturesId = names2id(ft, metaFeatures);
longtermFeaturesId = names2id(ft, longtermFeatures);
lateIntegrationId = names2id(ft, lateIntegrationFeatures);

function id = names2id(names, selectedNames)

id = [];
for k=1:length(names)
    for l=1:length(selectedNames)
        if strcmp(char(names(k)), char(selectedNames(l)))
            id = [id k];
        end
    end
end

