function features = getFeatures(ap, outputFile, selection, instruments, nbInstruments)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

if nargin<3
    selection = 0;
end

if nargin < 5
    instruments='';
   nbInstruments=1; 
end

[features.names features.metaFeaturesId ...
    features.longtermFeaturesId features.lateIntegrationFeaturesId] = getFeatureType(selection);

featureCompute = getFeatureComputeStrings(features.names);
features.handles = cellfun(@str2func, featureCompute, 'UniformOutput', false);


features.vectorLength = getFeatureVectorLength(features.names, ap);
features.nbColumns = zeros(1, nbInstruments);
features.nbLines = features.vectorLength(end);
features.precision = 'float32';
features.fileName = regexprep(outputFile, '.mat', '_');
features.instrumentNames = instruments;
features.instrumentFileSizes = cell(1, nbInstruments);
features.instrumentSizes = zeros(1, nbInstruments+1);

features.meanValues = zeros(features.nbLines, 1);
features.stdValues = zeros(features.nbLines, 1);