function R = longtermHandling(E, ap, featureType, commandId, outputSize)
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

%% featureType 0 : f, 1 : a, 2 : m

debug = 0;

commands = {...
    'vec = abs(fft(vec.*hanning(length(vec)).'', (ap.lt.nbBins+2)*2)); vec=(vec(2:end/2-1));', ... %% spec log10
    'vec=arCompute(vec, ap);', ... %% ar
    'vec=vec-mean(vec); vec=resample(vec, ap.lt.vectorLength, length(vec));', ... %% time domain
    'vec=removePolynom(vec, ap.lt.polynomOrder);', ... %% remove polynom
    'vec=vec(ap.lt.selectorStart+1:end); ', ... %% remove mean (spectral)
    'vec=vec(1:ap.lt.numcep);', ... %% selection (spectral)
    };

outputSizes = [ap.lt.nbBins, ap.lt.order, ap.lt.vectorLength, ap.lt.vectorLength, ...
    ap.lt.nbBins-ap.lt.selectorStart, ap.lt.numcep];

outputSize = outputSizes(commandId(end));

if debug
    featureType
    commandId
    outputSize
end

R = zeros(outputSize, size(E, 2));
for k=1:size(E, 2)
    if ~isnan(sum(E(:, k))) && sum(E(:, k))>0 && sum(E(:, k))<Inf
        F = zeros(ap.lt.nbBands, outputSize);
        index=1;
        for l=1:ap.lt.nbBands
            len = E(index, k);
            vec = E(index+1+len*featureType:index+len*(featureType+1), k);
            % vec=vec-mean(vec);
            % vec=vec/max(abs(vec));
            vec=vec(:).';
            index = index+3*len+1;
            if len
                %abs(fft(f.*hanning(length(f)), ap.lt.nbBins*2))
                for m=1:length(commandId)
                    eval(char(commands(commandId(m))));
                end
                if debug
                    whos vec
                end
                F(l, :)= vec.';
            end
        end
        feature = mean(F, 1);
        if find(commandId==1)
           feature=log10(feature+eps); 
        end
        R(:, k) = feature;
    end
end
